# Generated by go2rpm 1.8.2
%bcond_without check

# https://github.com/strukturag/nextcloud-spreed-signaling
%global goipath         github.com/strukturag/nextcloud-spreed-signaling
Version:                1.1.3

# REMOVE BEFORE SUBMITTING THIS FOR REVIEW
# ---
# New Fedora packages should use %%gometa -f, which makes the package
# ExclusiveArch to %%golang_arches_future and thus excludes the package from
# %%ix86. If the new package is needed as a dependency for another pacage,
# please consider removing that package from %%ix86 in the same way, instead of
# building more go packages for i686. If your package is not a leaf package,
# you'll need to coordinate the removal of the package's dependents first.
# ---
# REMOVE BEFORE SUBMITTING THIS FOR REVIEW
%gometa -f

%global common_description %{expand:
Standalone signaling server for Nextcloud Talk.}

%global golicenses      LICENSE
%global godocs          docs CHANGELOG.md README.md

Name:           %{goname}
Release:        5%{?dist}
Summary:        Standalone signaling server for Nextcloud Talk

License:        AGPL-3.0-only
URL:            %{gourl}
Source:         %{gosource}

# Local patches
Patch1001:      1001-dist-fix-ExecPaths-in-systemd-service-unit.patch

BuildRequires:  systemd-rpm-macros
BuildRequires:  golang-github-mailru-easyjson
BuildRequires:  golang-google-grpc
BuildRequires:  golang-google-protobuf
BuildRequires:  protobuf-compiler

%description %{common_description}

%gopkg

%prep
%goprep

# Local patches
%patch -P1001 -p1

%generate_buildrequires
%go_generate_buildrequires


%build
export GO111MODULE=off

for f in grpc_backend.proto grpc_internal.proto grpc_mcu.proto grpc_sessions.proto
do
  protoc --go_out=. --go_opt=paths=source_relative --go-grpc_out=. --go-grpc_opt=paths=source_relative $f
done

pushd %{gobuilddir}/src/%{goipath}
  for f in api_async.go api_backend.go api_grpc.go api_proxy.go api_signaling.go
  do
    GOPATH=%{gopath}:%{gobuilddir} easyjson --all $f
  done
popd

%gobuild -o %{gobuilddir}/bin/signaling %{goipath}/server
%gobuild -o %{gobuilddir}/bin/signaling-proxy %{goipath}/proxy
%gobuild -o %{gobuilddir}/bin/signaling-client %{goipath}/client

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

install -D -m 644 "dist/init/systemd/signaling.service" \
        %{buildroot}%{_unitdir}/signaling.service
install -D -m 600 "server.conf.in" \
        %{buildroot}%{_sysconfdir}/signaling/server.conf
install -D -m 600 "proxy.conf.in" \
        %{buildroot}%{_sysconfdir}/signaling/proxy.conf
chmod -R o-rwx %{buildroot}%{_sysconfdir}

%if %{with check}
%check
%gocheck
%endif

%pre
getent group signaling &>/dev/null || groupadd -r signaling
getent passwd signaling &>/dev/null || \
    /usr/sbin/useradd -r -g signaling -s /sbin/nologin \
        -c "Nextcloud Talk signaling server" -d / signaling

%post
%systemd_post signaling.service

%preun
%systemd_preun signaling.service

%postun
%systemd_postun_with_restart signaling.service

%files
%license LICENSE
%doc docs CHANGELOG.md README.md
%config(noreplace) %attr(-, signaling, signaling) %{_sysconfdir}/signaling
%{_bindir}/*
%{_unitdir}/signaling.service

%gopkgfiles

%changelog
* Sat Jan 18 2025 Fabrice Bellet <fabrice@bellet.info> - 1.1.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Sep 03 2024 Fabrice Bellet <fabrice@bellet.info> - 1.1.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Thu Jan 25 2024 Fabrice Bellet <fabrice@bellet.info> - 1.1.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sat Jan 20 2024 Fabrice Bellet <fabrice@bellet.info> - 1.1.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Oct 13 2023 Fabrice Bellet <fabrice@bellet.info> - 1.1.3-1
- New upstream release

* Sun Jul 23 2023 Fabrice Bellet <fabrice@bellet.info> - 1.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Jan 20 2023 Fabrice Bellet <fabrice@bellet.info> - 1.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Dec 22 2022 Fabrice Bellet <fabrice@bellet.info> - 1.0.0-2
- New upstream release
- remove @resources from SystemCallFilter
- dist: fix ExecPaths in systemd service unit

* Wed Jul 27 2022 Fabrice Bellet <fabrice@bellet.info> - 0.4.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon May 16 2022 Fabrice Bellet <fabrice@bellet.info> - 0.4.1-1
- New upstream release

* Sat Jan 29 2022 Fabrice Bellet <fabrice@bellet.info> - 0.3.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild
- Update to etcd 3.5.0

* Fri Jul 23 2021 Fabrice Bellet <fabrice@bellet.info> - 0.3.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sun Jul 04 2021 Fabrice Bellet <fabrice@bellet.info> - 0.3.0-1
- New upstream release

* Tue Jan 26 2021 Fabrice Bellet <fabrice@bellet.info> - 0.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Fri Jan 08 2021 Fabrice Bellet <fabrice@bellet.info> - 0.2.0-1
- New upstream release

* Fri Dec 04 2020 Fabrice Bellet <fabrice@bellet.info> - 0.1.0-1
- Initial package
